<!DOCTYPE html>
<html>
    <head>
        <title>Fundamentos de Javascript</title>
        <meta charset="UTF-8">
    </head>
    <body>
        <h1>Fundamentos de Javascript</h1>
        <script>
            // // "var" es una variable global, "let" es una variable local y "const" es una variable que no cambia
            // var hola = "Good Morning World"
            // let hello = "Good Morning World"
            // console.log(hello)
            // console.log(hola)
            // console.log(window.hola)
            // console.log(window.hello)
            // //Probando con var
            // console.log("***************var**************")
            // var musica = "Rock"
            // console.log("Variable Música antes del Bloque", musica)

            // {
            //     var musica = "Pop"
            //     console.log("Variable musica dentro del bloque", musica)
            // }

            // console.log("Variable musica despues del bloque", musica)
            // // Probando con let
            // console.log("***************let**************")
            // let musica2 = "Rock"
            // console.log("Variable Música antes del Bloque", musica2)

            // {
            //     let musica2 = "Pop"
            //     console.log("Variable musica dentro del bloque", musica2)
            // }

            // console.log("Variable musica despues del bloque", musica2)
            // // Tipos de valores compuestos se refiere a que accede a la referencia del valor
            // // objeto
            // const objeto = {
            //     nombre:"Victor",
            //     edad: 35
            // }
            // // arreglo
            // const colores = ["blanco", "negro", "azul"]
            // console.log(objeto)
            // console.log(colores)

            // objeto.correo = "victor.vamv17@gmail.com"
            // colores.push("naranja")

            // console.log(objeto)
            // console.log(colores)

            // // MODZILLA DEVELOP NETWORT(MDN) para cualquier duda de JavaScript
            // //Cadenas de Texto(Strings)
            // let nombre = "Victor"
            // let apellido = 'Vazquez'
            // let saludo = new String("Quiubo")
            // let lorem = "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua."
            // console.log(nombre, apellido, saludo)
            // console.log(nombre.length, 
            // apellido.length, 
            // saludo.length, 
            // nombre.toUpperCase(),
            // apellido.toLowerCase(),
            // lorem,
            // lorem.split(" "),
            // lorem.split(",")
            // )
            // // A esto se le llama Template String (``)   
            // let nombre = "Victor"
            // let apellido = "Vazquez"
            
            // let saludo = `Buenos dias ${nombre} ${apellido}`
            // console.log(saludo)
            // // Numbers
            // let a = 5
            // let b = new Number(1)
            // let c = 56
            // let d = "89.7"

            // console.log(a, b)
            // console.log(c.toFixed(1))
            // console.log(c.toFixed(5))
            // console.log(parseInt(c))
            // console.log(parseFloat(c))
            // console.log(typeof c, typeof d)
            // console.log(a + b)
            // console.log(c + parseInt(d))
            // console.log(c + parseFloat(d))

            // // Booleans
            // let verdadero = true
            // let falso = false
            // let v = Boolean(true)
            // let f = Boolean(false)

            // console.log(verdadero, falso, v, f)
            // console.log(typeof verdadero, typeof falso)

            // console.log(Boolean(0))
            // console.log(Boolean(-7))
            // console.log(Boolean(""))
            // console.log(Boolean(" "))
            // //Funciones
            // function estoEsUnaFuncion(){
            //     console.log("Texto")
            //     console.log(567.56)
            // }
            // function funcionConParametros(nombre, edad){
            //     console.log(`Mi nombre es ${nombre} y tengo ${edad} años`)
            // }
            // const funcionExpresada = function(){
            //     console.log("Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.")
            // }
            // estoEsUnaFuncion()
            // funcionConParametros("Victor", 25)
            // funcionExpresada()
            // // Arreglos
            // const a = []
            // const b = [12, "hola", [2,4,6], true]

            // console.log(a)
            // console.log(b)
            // console.log(b[2])
            // console.log(b[2][1])

            // const c = Array.of("X", "Y", "Z", 1, 2, 3)
            // console.log(c)

            // const d = Array(100).fill("copia")
            // console.log(d)

            // const e = new Array()
            // console.log(e)

            // const f = new Array("raton", "perro", "gato", 67 , 45)
            // console.log(f)

            // const colores = ["Verde", "Rojo", "Azul"]
            // console.log(colores)

            // colores.push("Negro")
            // console.log(colores)

            // colores.pop()
            // console.log(colores)

            // colores.forEach(function (elemento, i){
            //     console.log(`<li id=${i}>${elemento} </li>`)
            // })
            // //Objetos
            // const victor = {
            //     nombre: "Victor",
            //     apellido: "Vazquez",
            //     edad: 25,
            //     pasatiempos: ["Correr", "Jugar Videojuegos", "Escuchar Música"],
            //     soltero: false,
            //     contacto: {
            //         email: "victor.vamv17@gmail.com",
            //         celular: "5541372259"
            //     },
            //     saludar: function(){
            //         console.log("Hola a todos")
            //     },
            //     decirMiNombre: function(){
            //         console.log(`Hola me llamo ${this.nombre} ${this.apellido} y tengo ${this.edad} años y puedes llamar al número ${this.contacto.celular}`)
            //     }
            // }
            // console.log(victor)
            // console.log(victor["nombre"])
            // console.log(victor.nombre)
            // console.log(victor.contacto)
            // victor.saludar()
            // victor.decirMiNombre()
            // console.log()
            // console.log(victor.pasatiempos[2])
            // // Ciclos
            // let numeros = [10, 20, 30, 40, 50, 60, 70, 80, 90]
            // //Los objetos en JavaScript se basan en una key y value
            // const vamv= {
            //     nombre: "Victor",
            //     apellido: "Vazquez",
            //     edad: 25,
            //     telefono: "5541372259"
            // }
            // //For in recorre un objeto
            // for(const propiedad in vamv){
            //     console.log(`Key: ${propiedad}, Value: ${vamv[propiedad]}`)
            // }

            // for(const elemento of numeros){
            //     console.log(elemento)
            // }

            // let cadena = "Hola Mundo"

            // for(const caracter of cadena){
            //     console.log(caracter)
            // }
            // //Manejo de Errores
            // try {
            //     let numero = "s";
            //     if(isNaN(numero)){
            //         throw new Error("El caractér introducido no es un Número")
            //     }
            //     console.log(numero*numero)
            // } catch (error) {
            //     console.log(`Se produjo el siguiente ${error}`)
            // }

        //     //Destructuracion
        //     const componentes = ["ryzen 5800x", "Noctua NDH-15", "Memoria ram Veagance", "Mamba raton"]

        //    const [erg,ty,ti,lu]=componentes //Cada coma representa una variable
        //    console.log(erg,ty,ti,lu)

        //    //Sin destructuracion
        //    const componente1 = componentes[0]
        //    const componente2 = componentes[1]
        //    const componente3 = componentes[2]
        //    const componente4 = componentes[3]

        //    console.log(componente1,componente2,componente3,componente4)

        //    // Destructuracion de objetos
        //    const casa={
        //         puerta: "roja",
        //         ventana: "amarilla",
        //         cuartos: 3,
        //         jardin: false,
        //         habitantes: 4
        //    }

        //    const {jardin, puerta, ventana, habitantes, cuartos}= casa
        //    console.log(ventana)
        //    console.log(habitantes)
        //    console.log(cuartos)
        //    console.log(puerta)
        //    console.log(jardin)
        //    console.log("-----------------------------")
        //    //Sin destructuracion
        //    const jardin2 = casa["jardin"]
        //    console.log(jardin2)

        // //Prototipos y Herencia
        // function Animal(nombre, genero){
        //     this.nombre = nombre
        //     this.genero = genero
        
        // // Métodos agregados al prototipo de la función constructora
        //     Animal.prototype.sonar = function(){
        //         console.log("Hago sonidos por que estoy vivo")
        //     }

        //     Animal.prototype.saludar = function(){
        //         console.log(`Hola me llamo ${this.nombre}`)
        //     }
        // }

        // function Perro(nombre, genero, tamanio){
        //     this.super = Animal
        //     this.super(nombre, genero)
        //     this.tamanio = tamanio
        // }

        // Perro.prototype = new Animal()
        // Perro.prototype.constructor = Perro

        // Perro.prototype.sonar = function(){
        //     console.log("Soy un perro y mi sonido es un ladrido")
        // }

        // Perro.prototype.ladrar = function() {
        //     console.log("Guauuu Guauu!!!")
        // }

        // const snoopy = new Perro("Snoopy", "Macho", "Mediano"),
        //     lolaBunny = new Animal("Lola Bunny", "Hembra")

        // console.log(snoopy)
        // console.log(lolaBunny)

        // snoopy.sonar()
        // snoopy.saludar()
        // snoopy.ladrar()

        // lolaBunny.sonar()
        // lolaBunny.saludar()


        // //Clases(Prototipos)

        // class Animal{
        //     constructor(nombre, genero){
        //         this.nombre = nombre
        //         this.genero = genero
        //     }

        //     sonar(){
        //         console.log("Hago sonidos por que estoy vivo")
        //     }

        //     saludar(){
        //         console.log(`Hola me llamo ${this.nombre}`)
        //     }
        // }

        // class Perro extends Animal{
        //     constructor(nombre, genero, tamanio){
        //     super(nombre, genero)
        //     this.tamanio = tamanio
        //     this.raza = null
        //     }

        //     sonar(){
        //         console.log("Soy un perro y mi sonido es un ladrido")
        //     }

        //     ladrar(){
        //         console.log("Guauuu Guauuu!!!")
        //     }

        //     static queEres(){
        //         console.log("Los perros somos animales mamiferos que pertenecemos a la familia de los caninos. Somos considerados los mejores amigos del hombre")
        //     }

        //     get getRaza(){
        //         return this.raza
        //     }

        //     set setRaza(raza){
        //         this.raza = raza
        //     }
        // }

        // const mimi = new Animal("Mimi","Hembra"),
        //     scooby = new Perro("Scooby","Macho","Gigante")

        // console.log(mimi)
        // mimi.sonar()
        // mimi.saludar()

        // console.log(scooby)
        // scooby.sonar()
        // scooby.saludar()
        // scooby.ladrar()
        // Perro.queEres()
        
        // scooby.setRaza = "Gran Danes" 
        // console.log(scooby.getRaza) 
        // // Objeto Console  
        // console.table(Object.entries(console).sort()) 

        // const numeros = [1, 2, 3, 4, 5],
        //     vocales = ["a", "e", "i", "o", "u"]

        // console.table(numeros)
        // console.table(vocales)

        // const perro = {
        //     nombre: "Bonny",
        //     raza: "Boxer",
        //     color:"cafe"
        // }
        // console.table(perro)
        // console.clear()

        // console.time("Cuanto tiempo tarda mi código")
        // const arreglo = Array(10000000)

        // for(let i=0; i < arreglo.length; i++){
        //     arreglo[i] = i
        // }

        // console.timeEnd("Cuanto tiempo tarda mi código")

        // console.clear();

        // for(let i=0;i <= 100;i++){
        //     console.count("código for")
        //     console.log(i)
        // }

        // console.clear()

        // let x = 3,
        // y = 2,
        // pruebaXY = "Se espera que X siempre sea menor que Y";

        // console.assert(x < y,{x,y,pruebaXY})

        // //Math

        console.log(Math)

        let alerta = alert("Hola esto es una alerta"),
            confirmacion = confirm("Hola esto es una confirmacion"),
            aviso = prompt("Hola esto es un aviso y le permite al usuario ingresar un valor");

        console.log(alerta)
        console.log(confirmacion)
        console.log(aviso)
        </script>
    </body>
</html>